'use strict';

var _rollupPluginBabelHelpers = require('./_virtual/_rollupPluginBabelHelpers.js');
var Parrot = require('parrot-core');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var Parrot__default = /*#__PURE__*/_interopDefaultLegacy(Parrot);

class ParrotMiddleware extends Parrot__default["default"] {
  constructor(...args) {
    super(...args);
    _rollupPluginBabelHelpers.defineProperty(this, "normalizeRequest", req => req);
    _rollupPluginBabelHelpers.defineProperty(this, "resolver", (req, res, next) => response => {
      if (res.headersSent) {
        return;
      }
      if (!response) {
        this.logger.warn('No matching mock found for request', req.path);
        next();
        return;
      }
      const {
        body,
        contentType,
        status
      } = response;
      res.status(status);
      if (contentType) {
        res.type(contentType);
      }
      if (typeof body === 'object') {
        res.json(body);
      } else if (typeof body === 'undefined') {
        res.sendStatus(status);
      } else {
        res.send(body);
      }
    });
    _rollupPluginBabelHelpers.defineProperty(this, "getActiveScenarioOverride", req => req.cookies ? req.cookies.parrotScenarioOverride : undefined);
  }
}

module.exports = ParrotMiddleware;
